]> git.pld-linux.org Git - packages/rpm-pld-macros.git/blame_incremental - rpm.macros
remove --quiet option for systemctl actions that do not support it
[packages/rpm-pld-macros.git] / rpm.macros
... / ...
CommitLineData
1# vim:ts=4 sw=4 noet ft=spec
2#
3# PLD Linux rpm macros.
4# <http://www.pld-linux.org/>
5
6# can be used by builder script to check for version
7%rpm_build_macros {Revision}
8
9%epoch 0
10%x8664 x86_64 amd64 ia32e
11%arm armv3l armv4b armv4l armv5teb armv5tel
12
13# compiler version
14%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
15%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
16
17%__rm /bin/rm --interactive=never
18
19# Build system path macros.
20%__autoconf autoconf %{?debug:-Wall}
21%__automake automake -a -c -f --foreign
22%__autopoint autopoint --force
23
24# add parallel build flags: -jN
25# jobs macro is available since 1.657
26#
27# if you want to disable parallel build do:
28# echo '%__jobs %{nil}' >> ~/.rpmmacros
29%__jobs %{expand:%%global __jobs %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); [ "$_NCPUS" -gt 3 ] && echo $(($_NCPUS / 2)))%%{nil}}%__jobs
30
31# expands to -jN if %__jobs has a value
32%_smp_mflags %{expand:%%global _smp_mflags %(jobs=%{__jobs}; echo ${jobs:+-j$jobs}%%{nil})}%_smp_mflags
33
34%__make /usr/bin/make %{?_make_opts} %{?_smp_mflags}
35%__scons /usr/bin/scons %{?_smp_mflags}
36%__waf /usr/bin/waf %{?_smp_mflags}
37%__cmake /usr/bin/cmake
38
39%__gettextize { \
40 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
41 gettextize --copy --force --no-changelog; \
42 else \
43 gettextize --copy --force --no-changelog --intl; \
44 fi; \
45 if [ ! -f po/Makevars ]; then \
46 cp -f po/Makevars{.template,}; \
47 fi; \
48}
49
50%__glib_gettextize glib-gettextize --copy --force
51%__gnome_doc_common gnome-doc-common --copy
52%__gnome_doc_prepare gnome-doc-prepare --copy --force
53%__gtkdocize gtkdocize --copy
54%__intltoolize intltoolize --copy --force
55%__libtoolize libtoolize --copy --force --install
56
57# topdir is where builder script lives,
58# fallback to old style if SPECS/SOURCES dirs were found.
59%_topdir %{expand:%%global _topdir %(
60 if [ -d SPECS -a -d SOURCES ]; then
61 # old style rpmdir: in topdir
62 pwd
63 elif [ -d ../SPECS -a -d ../SOURCES ]; then
64 # old style rpmdir: in subdir
65 cd ..; pwd
66 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
67 # if old style rpm dir exist, go with it
68 echo $HOME/rpm; \
69 elif [ -x ../builder -a ! -d ../builder ]; then
70 # relative new style rpmdir: in package dir
71 cd ..; pwd
72 elif [ -x builder -a ! -d builder ]; then
73 # relative new style rpmdir: in packages
74 pwd
75 elif [ -x packages/builder -a ! -d packages/builder ]; then
76 # relative new style rpmdir: packages dir in current dir
77 cd packages; pwd
78 else
79 # fallback to new style rpmdir
80 echo $HOME/rpm/packages
81 fi; \
82)}%_topdir
83
84# if %{_topdir}/SPECS exists, it's old style structure
85%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
86%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
87
88# BUILD/RPMS/SRPMS are on same level by default as packages dir, if these exist
89# if they don't exist assume we are having custom topdir (which is not named as
90# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
91# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therefore the extra echo
92%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
93%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
94%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
95
96# The number of cvs changelog entries kept when building package.
97%_buildchangelogtruncate 20
98
99%dependencytracking %{nil}
100
101# Relations between package names that cause dependency loops
102# with legacy packages that cannot be fixed. Relations are
103# specified as
104# p>q
105# where package p has a Requires: on something that package q Provides:
106#
107# XXX Note: that there cannot be any whitespace within the string "p>q",
108# and that both p and q are package names (i.e. no version/release).
109%_dependency_whiteout %{nil}
110
111#-----------------------------------------------------------------
112#
113# (re)definition of %{rpm*flags} with %filterout_* support
114# BuildRequires: awk
115# BuildRequires: rpmbuild(macros) >= 1.315
116#
117# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
118# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
119# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
120# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
121# %rpmldflags = %optldflags - %filterout_ld
122#
123# Regular expressions are supported, but to avoid some character be treated
124# as regular expression it must be escaped twice.
125
126%filter_out \
127 for (i = 1; i in I; i++) { A=0; \
128 for (f in F) { \
129 if (I[i] ~ "^" F[f] "$") A=1; \
130 }; \
131 if (!A) printf(I[i] FS); \
132 }
133
134%rpmcflags %(awk 'BEGIN {
135 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
136 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
137 %{filter_out}
138}')
139
140%rpmcxxflags %(awk 'BEGIN {
141 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
142 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
143 %{filter_out}
144}')
145
146%rpmcppflags %(awk 'BEGIN {
147 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
148 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
149 %{filter_out}
150}')
151
152%rpmldflags %(awk 'BEGIN {
153 split("%{?optldflags}",I);
154 split("%{?filterout_ld}",F)
155 %{filter_out}
156}')
157
158# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
159# but, don't use it, better use gcc as linker
160%ld_rpmldflags %(awk 'BEGIN {
161 split("%{rpmldflags}",F);
162 for (f in F) {
163 s = F[f];
164 if (s ~ /^-Wl,/) {
165 s = substr(s,5);
166 gsub(/,/," ",s);
167 };
168 printf(s FS);
169 };
170}')
171
172#-----------------------------------------------------------------
173#
174# Generate a command which cleans environment, leaving only the
175# most important variables.
176# If any spec requires any additional environment it should
177# redefine %_preserve_env in following manner:
178#
179# # ADDITIONAL_VAR is required because [a good reason here]
180# %define _preserve_env ADDITIONAL_VAR
181
182%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
183
184# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
185%_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
186 split("%{?_preserve_env:%_preserve_env %_preserve_env_base}%{!?_preserve_env:%_preserve_env_base}", P);
187 for (i in P) {
188 p = P[i];
189 if (!ENVIRON[p] || d[p]) {
190 continue;
191 }
192 d[p] = 1;
193 split(ENVIRON[p], V, "");
194 val = p "=";
195 for (j = 1; j in V; j++) {
196 v = V[j];
197 if (v == q)
198 v = qq;
199 else if (v == "\\"")
200 v = q2q;
201 else if (v == "\\\\")
202 v = "\\\\\\\\";
203 else
204 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
205 val = val "" v;
206 }
207 printf(val " ");
208 }
209}')
210
211# override %__spec_build_pre and %__spec_install_pre from macros.rpmbuild
212# adding %{_clean_env}
213%__spec_build_pre %{_clean_env}\
214%{___build_pre}\
215%{nil}
216%__spec_install_pre %{_clean_env}\
217%{___build_pre}\
218%{?buildroot:%{__rm} -rf '%{buildroot}'; %{__mkdir_p} '%{buildroot}'}\
219%{nil}
220
221#-----------------------------------------------------------------
222%configure2_13 { \
223 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
224 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
225 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
226 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
227 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
228 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
229 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
230 %{?__cc:CC="%{__cc}" ; export CC ; } \
231 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
232 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
233 --host=%{_target_platform} \
234 --prefix=%{_prefix} \
235 --exec-prefix=%{_exec_prefix} \
236 --bindir=%{_bindir} \
237 --sbindir=%{_sbindir} \
238 --sysconfdir=%{_sysconfdir} \
239 --datadir=%{_datadir} \
240 --includedir=%{_includedir} \
241 --libdir=%{_libdir} \
242 --libexecdir=%{_libexecdir} \
243 --localstatedir=%{_localstatedir} \
244 --sharedstatedir=%{_sharedstatedir} \
245 --mandir=%{_mandir} \
246 --infodir=%{_infodir} \
247 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
248 %{dependencytracking} \
249}
250
251# Note: pass only standard cmake macros here.
252# The only exception is SYSCONF_INSTALL_DIR, used commonly in KDE packages,
253# where the default (${CMAKE_INSTALL_PREFIX}/etc) is not FHS-compliant and
254# absolute path MUST be used to comply with FHS.
255# The other non-standard cmake macros used commonly in KDE
256# (INCLUDE_INSTALL_DIR, LIB_INSTALL_DIR, SHARE_INSTALL_PREFIX)
257# have sane default values in KDE, and some packages use these names
258# in different way (e.g. expect them to be always relative or always
259# absolute).
260%cmake \
261%{?__cc:CC="${CC:-%{__cc}}"} \\\
262%{?__cxx:CXX="${CXX:-%{__cxx}}"} \\\
263CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
264%{__cmake} \\\
265 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
266 -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
267 -DCMAKE_INSTALL_BINDIR:PATH=%{_bindir} \\\
268 -DCMAKE_INSTALL_SBINDIR:PATH=%{_sbindir} \\\
269 -DCMAKE_INSTALL_LIBEXECDIR:PATH=%{_libexecdir} \\\
270 -DCMAKE_INSTALL_SYSCONFDIR:PATH=%{_sysconfdir} \\\
271 -DCMAKE_INSTALL_SHAREDSTATEDIRPATH:PATH=%{_sharedstatedir} \\\
272 -DCMAKE_INSTALL_LOCALSTATEDIRPATH:PATH=%{_localstatedir} \\\
273 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
274 -DCMAKE_INSTALL_INCLUDEDIR:PATH=%{_includedir} \\\
275 -DCMAKE_INSTALL_OLDINCLUDEDIR:PATH=%{_includedir} \\\
276 -DCMAKE_INSTALL_DATAROOTDIR:PATH=%{_datadir} \\\
277 -DCMAKE_INSTALL_DATADIR:PATH=%{_datadir} \\\
278 -DCMAKE_INSTALL_INFODIR:PATH=%{_infodir} \\\
279 -DCMAKE_INSTALL_LOCALEDIR:PATH=%{_localedir} \\\
280 -DCMAKE_INSTALL_MANDIR:PATH=%{_mandir} \\\
281 -DCMAKE_INSTALL_DOCDIR:PATH=%{_docdir} \\\
282 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
283 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
284 -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
285 -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
286 -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
287 -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
288 -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
289 -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
290%if "%{_lib}" == "lib64" \
291 -DLIB_SUFFIX=64 \\\
292%endif \
293%if "%{_lib}" == "libx32" \
294 -DLIB_SUFFIX=x32 \\\
295%endif \
296 -DBUILD_SHARED_LIBS:BOOL=ON \\\
297%{nil}
298
299%scons { \
300%{__scons} \
301 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
302 CFLAGS="${CFLAGS:-%rpmcflags}" \
303 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
304 FFLAGS="${FFLAGS:-%rpmcflags}" \
305 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
306 %{?__cc:CC="%{__cc}"} \
307 %{?__cxx:CXX="%{__cxx}"} \
308 libsuffix=%{_lib} \
309 prefix=%{_prefix} \
310}
311
312# waf. see waf.spec
313%waf { \
314CC="%{__cc}" \
315CXX="%{__cxx}" \
316CPP="%{__cpp}" \
317CFLAGS="%{rpmcflags}" \
318CXXFLAGS="%{rpmcxxflags}" \
319LINKFLAGS="%{rpmldflags}" \
320%{__waf} \
321}
322
323#----------------------------------------------------------------
324#%configure_cache 0
325%configure_cache_file %{buildroot}.configure.cache
326
327%configure {./configure \
328 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
329 CFLAGS="${CFLAGS:-%rpmcflags}" \
330 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
331 FFLAGS="${FFLAGS:-%rpmcflags}" \
332 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
333 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
334 %{?__cc:CC="%{__cc}"} \
335 %{?__cxx:CXX="%{__cxx}"} \
336 --host=%{_target_platform} \
337 --build=%{_target_platform} \
338 --prefix=%{_prefix} \
339 --exec-prefix=%{_exec_prefix} \
340 --bindir=%{_bindir} \
341 --sbindir=%{_sbindir} \
342 --sysconfdir=%{_sysconfdir} \
343 --datadir=%{_datadir} \
344 --includedir=%{_includedir} \
345 --libdir=%{_libdir} \
346 --libexecdir=%{_libexecdir} \
347 --localstatedir=%{_localstatedir} \
348 --sharedstatedir=%{_sharedstatedir} \
349 --mandir=%{_mandir} \
350 --infodir=%{_infodir} \
351 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
352 %{dependencytracking} \
353 %{?configure_cache:--cache-file=%{configure_cache_file}} \
354}
355
356# Simple macros to simplify adding bconded options to configure scripts.
357# Each macro requires bcond name and accepts optional option name, if option
358# isn't specified bcond name is used as option name. Options returning
359# --with and --enable also allow third argument which will be added as value
360# ( --with-option=value or --enable-option=value ) in case or positive
361# condition, but won't be added otherwise ( nothing or just --disable-option ).
362
363# Requirements:
364# BuildRequires: rpmbuild(macros) >= 1.527
365
366# Usage example:
367# %{__enable bcond} - returns --enable-bcond iff build condition is set
368# %{__disable bcond option} - returns --enable-option iff bcond is not set
369# %{__enable_disable bcond option value} - returns --enable-option=value if
370# bcond is set, returns --disable-option otherwise
371
372# expand bconds to --enable-something and --disable-something
373%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
374%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
375%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
376
377# same as above, but condition inverted
378%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
379%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
380%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
381
382# expand bconds to --with-something and --without-something
383%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
384%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
385%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
386
387# same as above, but condition inverted
388%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
389%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
390%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
391
392#-----------------------------------------------------------------
393
394# overload to insert debuginfo package
395%prep \
396%if 0%{?_enable_debug_packages}\
397%{debug_package}\
398%endif\
399%%prep\
400%{nil}
401
402# Location of autoconf macros
403%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
404
405# Location of omf files
406%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
407
408# Location of pkgconfig files
409%_pkgconfigdir /usr/%{_lib}/pkgconfig
410# noarch pkgconfig files
411%_npkgconfigdir /usr/share/pkgconfig
412
413# Location of desktop files
414%_desktopdir /usr/share/applications
415%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
416
417# Location of pixmaps for applnk/desktop files
418%_pixmapsdir /usr/share/pixmaps
419
420# Location of themable icons for applnk/desktop files
421%_iconsdir /usr/share/icons
422
423# Location of fonts directories
424%_fontsdir /usr/share/fonts
425
426# Location of Gtk and associated libraries documentation
427%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
428
429# Location of KDE documentation
430%_kdedocdir %{_defaultdocdir}/kde/HTML
431
432# unsermake script
433%__unsermake /usr/share/unsermake/unsermake
434
435# Current date
436%date %(LC_ALL=C date +"%a %b %d %Y")
437
438# Example files, programs, scripts...
439%_examplesdir /usr/src/examples
440
441# SysV-style initscripts dir
442%_initddir /etc/rc.d/init.d
443
444# If non-empty "debug" macro defined, add "dbg" suffix to release number
445%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
446
447# Bootstrap release macros.
448# Usage:
449# %bcond_with bootstrap
450# Release: %{bootstrap_release 1}
451#
452# Package will have release 1 if built normally,
453# and release 0.zzz.bootstrap if built with bootstrap
454%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
455
456# Requires name = version-release
457%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
458# Requires: name = version
459%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
460# Requires: name = version (version based on querying package %2)
461%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
462
463# Requires: name >= version
464%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
465# Requires: name >= version (version based on querying package %2)
466%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
467
468# helper for renaming packages
469# %rename old-package
470%rename() \
471Obsoletes: %{1} < %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}} \
472Provides: %{1} = %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}}
473
474%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
475
476# sgml macros
477%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
478%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
479%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
480%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
481%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
482%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
483%docbook_sgmlcat_fix() { for l in \
484'' \
485' -- default decl --' \
486'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
487' -- hacks for opensp --' \
488'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
489'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
490'' \
491; do echo $l; done >> %1 \
492}
493
494# vim - "
495
496# minimum file size needed for compressed documents.
497# just smaller files than this get larger when compressed.
498# some stats:
499# - 0 byte file compressed was 25 bytes .gz
500# - 39 byte file was compressed as 57
501# - with test/test.spec@man 158 byte file was compressed also 158
502%_min_compress_bytes 159
503
504#-----------------------------------------------------------------
505# find and gzip all files in %{_mandir} and %{infodir}
506#
507# Requires: xargs, find
508#
509#%no_install_post_compress_docs 1
510%__spec_install_post_compress_docs { \
511%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
512 %{!?debug:set +x;} \
513 for i in /usr/share/man /usr/X11R6/man; do \
514 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
515 echo "Compress man pages: $i"; \
516 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
517 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
518 find $RPM_BUILD_ROOT$i -type l | while read a; do \
519 m=$(readlink "$a"); \
520 if [[ "$m" = */* ]]; then \
521 # handle links to different man section \
522 l=$(readlink -f "$a"); \
523 # full/relative paths that resolve symlink \
524 l=${l#$RPM_BUILD_ROOT/usr/share/man/}; \
525 l=${l#$RPM_BUILD_ROOT/usr/X11R6/man/}; \
526 # full paths that do not resolve symlink \
527 l=${l#/usr/share/man/}; \
528 l=${l#/usr/X11R6/man/}; \
529 else \
530 l=${a#$RPM_BUILD_ROOT$i/}; \
531 l=${l%/*}; \
532 l="$l/$m"; \
533 fi; \
534 rm -f $a; \
535 echo ".so $l" > $a; \
536 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
537 done; \
538 # verify that .so links point to existing files (not allowed to point to "other package") \
539 # TODO: iterate over all man dirs, but in Th there is only one true man dir \
540 err=$(grep -rl '^\.so ' "$RPM_BUILD_ROOT$i" | while read doc; do \
541 l=$(grep -r '^\.so ' "$doc"); \
542 l=${l#.so }; \
543 d=$(dirname $doc); \
544 test -e $RPM_BUILD_ROOT$i/$l || test -e $d/$(basename $l) || echo " ${doc#$RPM_BUILD_ROOT} points to inexistent manpage: $l"; \
545 done); \
546 test "$err" != "" && { echo >&2 "Man page link errors:"; echo >&2 "$err"; exit 1; }; \
547 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
548 fi; \
549 done; \
550 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
551 echo "Compress info pages: %{_infodir}"; \
552 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
553 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
554 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
555 fi; \
556}; __spec_install_post_compress_docs } }
557
558#-----------------------------------------------------------------
559# Strip executable binaries and shared object files
560#
561# Requires: find, awk, strip, cut, xargs
562#
563# Special macros which affect this process:
564#%no_install_post_strip 1 # disable stripping at all
565#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
566#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
567#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
568#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
569#
570%__spec_install_post_strip {%{!?debug: \
571%{!?no_install_post_strip:__spec_install_post_strip() { \
572%{!?debug:set +x;} \
573if [ -d "$RPM_BUILD_ROOT" ]; then \
574 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
575 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
576 if [ "$modulelist" ]; then \
577 modulecount=$(echo "$modulelist" | wc -l); \
578 printf "Stripping %d kernel modules..." $modulecount; \
579 echo "$modulelist" | xargs -l512 chmod u+w; \
580 echo "$modulelist" | xargs -l512 %{__strip} -g --remove-section=.comment --remove-section=.note.GNU-stack; \
581 echo "DONE"; \
582 fi; \
583 fi; \
584 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
585 if [ -n "$filelist" ]; then \
586 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
587 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
588 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
589 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
590 if [ -n "$elfexelist" ]; then \
591 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
592 echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
593 echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
594 echo "DONE"; \
595 fi; \
596 if [ -n "$elfsharedlist" ]; then \
597 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
598 echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
599 echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
600 echo "DONE"; \
601 fi; \
602 if [ -n "$archiveslist" ]; then \
603 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
604 echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
605 echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
606 echo "DONE"; \
607 fi; \
608 fi; \
609 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
610 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
611 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
612 if [ -n "$filelist_all" ]; then \
613 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
614 chmod u+w $filelist_all; \
615 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
616 echo "DONE"; \
617 fi; \
618 if [ -n "$filelist_unneeded" ]; then \
619 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
620 chmod u+w $filelist_unneeded; \
621 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
622 echo "DONE"; \
623 fi; \
624 if [ -n "$filelist_debug" ]; then \
625 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
626 chmod u+w $filelist_debug; \
627 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
628 echo "DONE"; \
629 fi; \
630fi; }; __spec_install_post_strip } } }
631
632#-----------------------------------------------------------------
633# remove all RPATH/RUNPATH from executable binaries and shared object files
634#
635# Requires: find, awk, cut, xargs, chrpath, uname
636#
637# Special macros which affect this process
638#%no_install_post_chrpath 1 # disable chrpath at all
639#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
640#
641%__spec_install_post_chrpath {%{!?debug: \
642%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
643%{!?debug:set +x;} \
644if [ -d "$RPM_BUILD_ROOT" ]; then \
645 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
646 if [ -n "$files" ]; then \
647 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
648 fi; \
649 if [ -n "$objs" ]; then \
650 printf "Remove RPATH/RUNPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
651 echo "$objs" | \
652 while read file; do \
653 rpath= ; \
654 chmod u+w "$file"; \
655 for dir in $(chrpath -l "$file" | awk '/(R|RUN)PATH=/ { gsub(/.*RPATH=/,""); gsub(/.*RUNPATH=/,""); gsub(/:/," "); print $0 }'); do \
656 case $dir in \
657 '$ORIGIN' ) \
658 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
659 else rpath="$rpath:$dir" ; fi ; \
660 continue ; \
661 ;; \
662 esac ; \
663 newdir=$(readlink -m "$dir"); \
664 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
665 case $dir in \
666 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
667 echo "remove-rpath: $dir in $file"; \
668 ;; \
669 * ) \
670 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
671 else rpath="$rpath:$dir" ; fi ; \
672 ;; \
673 esac ; \
674 done ; \
675 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
676 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
677 done; \
678 fi; \
679fi; }; __spec_install_post_chrpath } } }
680
681# vim: "
682
683#-----------------------------------------------------------------
684# Find all shared object files with unresolved symbols. Warn
685# and terminate if any found (termination can be turned off by define).
686#%no_install_post_check_so 1
687#%skip_post_check_so libwithunresolvedok.so.*
688#
689# NOTE: define skip_post_check_so only if such library really requires
690# unresolved symbols and always leave a comment why it is required:
691# # executable provides symbols foo, bar for those libraries:
692# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
693#
694%__spec_install_post_check_so { \
695__spec_install_post_check_so() { \
696%{!?debug:set +x;} \
697 fail=0; \
698 printf "Searching for shared objects with unresolved symbols..."; \
699 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
700 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
701 done ; \
702 echo " DONE"; \
703 %{!?no_install_post_check_so:return $fail;} \
704}; __spec_install_post_check_so }}
705
706#-----------------------------------------------------------------
707# Verify that for each directory under /var/run package contains
708# tmpfiles.d configuration. Warn and terminate build if config is
709# missing.
710#
711#%no_install_post_check_tmpfiles 1
712#
713%__spec_install_post_check_tmpfiles { \
714__spec_install_post_check_tmpfiles() { \
715%{!?debug:set +x;} \
716 fail=0; \
717 echo "Checking /var/run <-> tmpfiles.d completeness..."; \
718 for d in $RPM_BUILD_ROOT/var/run/*; do \
719 [ -d "$d" ] || continue; \
720 d=${d##$RPM_BUILD_ROOT}; \
721 if ! grep -qsF "$d" $RPM_BUILD_ROOT/usr/lib/tmpfiles.d/*.conf $RPM_BUILD_ROOT/etc/tmpfiles.d/*.conf; then\
722 echo "No tmpfiles configuration for '$d'";\
723 fail=1 ; \
724 fi \
725 done ; \
726 echo " DONE"; \
727 %{!?no_install_post_check_tmpfiles:return $fail;} \
728}; __spec_install_post_check_tmpfiles }}
729
730#-----------------------------------------------------------------
731# Verify that scripts have reasonable shebangs
732# Test spec: see "test/spec_install_post_check_shebangs" branch on packages/test.spec
733#
734#%no_install_post_check_shebangs 1
735#
736%__spec_install_post_check_shebangs { \
737__spec_install_post_check_shebangs() { \
738%{!?debug:set +x;} \
739 fail=0; \
740 echo "Checking script shebangs..."; \
741 find $RPM_BUILD_ROOT -type f -perm -500 -print | \
742 while read f ; do \
743 shebang="$(sed -e'1s/#! *\(.*\)/\1/;t;d;q' "$f")" ; \
744 f="${f##$RPM_BUILD_ROOT}"; \
745 case "$shebang" in \
746 "%{__python}"|"%{__python3}"|"%{__python} "*|"%{__python3} "* \
747 |"/usr/bin/python%{py_ver}"|"/usr/bin/python%{py_ver} "* \
748 |"/usr/bin/python%{py3_ver}"|"/usr/bin/python%{py3_ver} "*) \
749 ;; \
750 "/usr/bin/env python"*|"/usr/bin/python"|"/usr/bin/python "*) \
751 echo "$f starts with '#!$shebang', should be '#!%{__python}' or '#!%{__python3}'" >&2;\
752 fail=1 ; \
753 ;; \
754 "/usr/bin/env "*) \
755 echo "$f starts with '#!$shebang', should be explicit interpreter path" >&2;\
756 fail=1 ; \
757 ;; \
758 *) ;;\
759 esac ; \
760 done ; \
761 echo " DONE" ; \
762}; %{!?no_install_post_check_shebangs:__spec_install_post_check_shebangs} }
763
764# Remove common Perl files we don't package
765%__spec_install_post_perl_clean {\
766%{!?no_install_post_perl_clean: \
767%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
768} }
769
770#-----------------------------------------------------------------
771# Update GConf2 schemas
772#
773# Requires: GConf2
774#
775%gconf_schema_install() \
776 umask 022; \
777 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
778 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
779%{nil}
780
781%gconf_schema_uninstall() \
782if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
783 umask 022; \
784 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
785 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
786fi; \
787%{nil}
788
789#-----------------------------------------------------------------
790# Update desktop MIME database
791# requires: desktop-file-utils
792%update_desktop_database() {{ \
793 umask 022; \
794 /usr/bin/update-desktop-database -q; \
795};} \
796%{nil}
797
798%update_desktop_database_post %update_desktop_database
799
800%update_desktop_database_postun() {{ \
801if [ "$1" = "0" ]; then \
802 %update_desktop_database \
803fi; \
804};} \
805%{nil}
806
807#-----------------------------------------------------------------
808# Update shared MIME info database
809# requires: shared-mime-info
810# Note: https://bugs.freedesktop.org/show_bug.cgi?id=70366#c19
811# https://bugzilla.redhat.com/show_bug.cgi?id=1052173
812# TODO: if you want this running with fdatasync(), make sure it's:
813# 1. announcing ~minute delay by echoing appropriate message,
814# 2. running only once after rpm transaction.
815#
816%update_mime_database() {{ \
817 umask 022; \
818 PKGSYSTEM_ENABLE_FSYNC=0 \\\
819 /usr/bin/update-mime-database %{_datadir}/mime; \
820};} \
821%{nil}
822
823#-----------------------------------------------------------------
824# Update icon cache
825# BuildRequires: rpmbuild(macros) >= 1.596
826# Requires: hicolor-icon-theme
827#
828%update_icon_cache() {{ \
829 %{!?1:%{error:%{0}: Required theme name missing}} \
830 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
831 umask 022; \
832 touch --no-create %{_iconsdir}/%1; \
833 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
834 fi; \
835};} \
836%{nil}
837
838#-----------------------------------------------------------------
839# Update scrollkeeper database
840# requires: scrollkeeper
841#
842%scrollkeeper_update_post() \
843 /usr/bin/scrollkeeper-update -q; \
844%{nil}
845
846%scrollkeeper_update_postun() \
847if [ "$1" = "0" ]; then \
848 /usr/bin/scrollkeeper-update -q; \
849fi; \
850%{nil}
851
852#-----------------------------------------------------------------
853# Compile GSettings schemas
854# requires: glib2 >= 1:2.26.0
855#
856%glib_compile_schemas() {{ \
857 umask 022; \
858 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
859};} \
860%{nil}
861
862#-----------------------------------------------------------------
863# post %install sequence:
864# - autodeps exceptions
865# - compress all man and info pages,
866# - strip all ELF executables and ELF shared objects if not %debug.
867# - compress kernel modules if any
868
869###################################################################
870# Requires/Provides automation
871# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
872#
873%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
874%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
875%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
876%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
877%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq) \
878 %{?_noautoreq: %{_noautoreq}} \
879 %{?_noautoreq_pear: %{__noauto_regexp_helper -p pear %{_noautoreq_pear}}} \
880 %{?_noautoreq_perl: %{__noauto_regexp_helper -p perl %{_noautoreq_perl}}} \
881 %{?_noautoreq_java: %{__noauto_regexp_helper -p java %{_noautoreq_java}}} \
882 %{?_noautoreq_pyegg: %{__noauto_regexp_helper -p pythonegg %{_noautoreq_pyegg}}} \
883 %{?_noautoreq_py3egg: %{__noauto_regexp_helper -p python3egg %{_noautoreq_py3egg}}} \
884 %{nil}
885
886# helper for wrapping _noautoreq between perl() or pear()
887# Author: Elan Ruusamäe <glen@pld-linux.org>
888# Usage:
889# BuildRequires: rpmbuild(macros) >= 1.654
890# %define _noautoreq_pear Excluded.php PEAR/Something.php
891# %define _noautoreq_perl Apache::.*
892# BuildRequires: rpmbuild(macros) >= 1.672
893# %define _noautoreq_java ClassDataVersion
894#
895%__noauto_regexp_helper(p:) %(echo "%*" | awk 'BEGIN{RS=" "}{printf("%{-p*}%{__qchar}(%%s%{__qchar}) ", $1)}')
896# detect quote character runtime
897%__qchar_4 \\\\%{nil}
898%__qchar_5 \\\\\\%{nil}
899%__qchar %{expand:%%global __qchar %%__qchar_%(echo %{_rpmversion} | cut -c1)}%__qchar
900
901#%_noautocompressdoc %{nil}
902#
903%_missing_doc_files_terminate_build 1%{nil}
904%_unpackaged_files_terminate_build %{nil}
905# (X)emacs support
906%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
907%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
908%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
909
910%__php_provides %{nil}
911%__php_requires %{nil}
912%__perl_provides %{nil}
913%__perl_requires %{nil}
914%__mono_provides %{nil}
915%__mono_requires %{nil}
916
917# Perl specific macro definitions.
918%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
919%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
920%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
921%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
922%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
923%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
924
925# Ruby
926%__ruby /usr/bin/ruby
927
928# Ruby ABI version
929# NOTE: %ruby_version may be empty, depending how Ruby was built
930%ruby_abi %{expand:%%global ruby_abi %(%{__ruby} -r rbconfig -e 'print [RbConfig::CONFIG["MAJOR"], RbConfig::CONFIG["MINOR"]].join(".")' 2>/dev/null || echo ERROR)}%ruby_abi
931
932# get rbconfig parameter
933%__ruby_rbconfig() %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["%1"]' 2>/dev/null || echo ERROR)
934%__ruby_rbconfig_path() %(%{__ruby} -r rbconfig -r pathname -e 'print Pathname(RbConfig::CONFIG["%1"]).cleanpath' 2>/dev/null || echo ERROR)
935
936%ruby_archdir %{expand:%%global ruby_archdir %{__ruby_rbconfig_path archdir}}%ruby_archdir
937%ruby_libdir %{expand:%%global ruby_libdir %{__ruby_rbconfig rubylibdir}}%ruby_libdir
938%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'print File.join(RbConfig::CONFIG["datadir"], "ri", RbConfig::CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
939%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %{__ruby_rbconfig_path rubylibdir}}%ruby_rubylibdir
940%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %{__ruby_rbconfig vendorarchdir}}%ruby_vendorarchdir
941%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %{__ruby_rbconfig_path vendorlibdir}}%ruby_vendorlibdir
942%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %{__ruby_rbconfig sitearchdir}}%ruby_sitearchdir
943%ruby_sitedir %{expand:%%global ruby_sitedir %{__ruby_rbconfig sitedir}}%ruby_sitedir
944%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %{__ruby_rbconfig_path sitelibdir}}%ruby_sitelibdir
945%ruby_rdocdir /usr/share/rdoc
946%ruby_vendordir %{expand:%%global ruby_vendordir %{__ruby_rbconfig vendordir}}%ruby_vendordir
947%ruby_version %{expand:%%global ruby_version %(r=%{__ruby_rbconfig ruby_version}; echo ${r:-%%nil})}%ruby_version
948
949%ruby_gemdir %{expand:%%global ruby_gemdir %(%{__ruby} -r rubygems -e 'puts Gem.respond_to?(:default_dirs) ? Gem.default_dirs[:system][:gem_dir] : Gem.path.first' 2>/dev/null || echo ERROR)}%{ruby_gemdir}
950%ruby_specdir %{ruby_gemdir}/specifications
951
952# deprecated, ruby 2.0 noarch packages are versionless and extension dependency is generated by rpm5
953%ruby_ver_requires_eq %{nil}
954%ruby_mod_ver_requires_eq %{nil}
955
956%php_pear_dir /usr/share/pear
957%php_data_dir /usr/share/php
958%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
959%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
960%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
961
962# extract php/zend api versions
963%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
964%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
965%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
966%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
967%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
968%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
969%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
970%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
971# "_ts" if ZTS enabled, empty otherwise
972%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
973
974# name of php package
975%php_name php%{?php_suffix}
976# use rpmbuild -D 'php_suffix 54' to build php extension for php 5.4
977# NOTE: error output must be empty. otherwise can't build pecl packages if no php*-devel is installed
978%php_suffix %{expand:%%global php_suffix %(c=$(php-config --sysconfdir 2>/dev/null) || echo '' && echo ${c#/etc/php})%%{nil}}%php_suffix
979
980# phpXY, version always present for using current php version (in regards of php*-devel package)
981%php_versuffix %{expand:%%global php_versuffix %((IFS=.; set -- $(php-config --version); echo $1$2))%%{nil}}%php_versuffix
982
983# php cli. version that php headers are installed for
984%__php /usr/bin/php%{php_versuffix}
985
986# helper macro
987%__php_api_requires() Requires: %{php_name}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
988
989# macros for public use
990# for php extensions (php-pecl)
991%requires_php_extension %{__php_api_requires modules_api php_api_version} \
992%{__php_api_requires zend_module_api} \
993%{__php_api_requires debug php_debug} \
994%{__php_api_requires thread-safety _zend_zts}
995
996# for zend extensions
997%requires_zend_extension %{__php_api_requires zend_module_api} \
998%{__php_api_requires zend_extension_api} \
999%{__php_api_requires debug php_debug} \
1000%{__php_api_requires thread-safety _zend_zts}
1001
1002# for php pdo modules (php-pecl-PDO_*)
1003%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
1004
1005# for using PHP post scripts. for PHP >= 5.0
1006%php_webserver_restart \
1007[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
1008[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
1009if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
1010 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
1011 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
1012 %service -q php-fcgi restart \
1013 fi \
1014fi \
1015if [ -x /etc/rc.d/init.d/%{php_name}-fpm ]; then \
1016 %service -q %{php_name}-fpm restart \
1017fi \
1018%{nil}
1019
1020# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
1021%php4_webserver_restart \
1022[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
1023[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
1024if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
1025 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
1026 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
1027 %service -q php-fcgi restart \
1028 fi \
1029fi \
1030%{nil}
1031
1032# X.org helper macros
1033%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
1034%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
1035
1036%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
1037%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
1038%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
1039%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
1040%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
1041# vim: '
1042
1043%requires_xorg_xserver_extension \
1044%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1045%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1046%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
1047%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
1048%{nil}
1049
1050%requires_xorg_xserver_xinput \
1051%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1052%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1053%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
1054%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
1055%{nil}
1056
1057%requires_xorg_xserver_font \
1058%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1059%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1060%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
1061%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
1062%{nil}
1063
1064%requires_xorg_xserver_videodrv \
1065%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1066%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1067%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
1068%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
1069%{nil}
1070
1071# TCL specific macro definitions.
1072# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
1073%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
1074%tcl_sitearch %{_libdir}/tcl%{tcl_version}
1075%tcl_sitelib %{_datadir}/tcl%{tcl_version}
1076
1077# Python specific macro definitions.
1078# python main version
1079%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
1080
1081# directories
1082%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
1083%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
1084%py_scriptdir %{py_prefix}/share/python%{py_ver}
1085%py_incdir /usr/include/python%{py_ver}
1086%py_sitedir %{py_libdir}/site-packages
1087%py_sitescriptdir %{py_scriptdir}/site-packages
1088%py_dyndir %{py_libdir}/lib-dynload
1089
1090# pure python modules compilation
1091%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1092
1093%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1094
1095# Software written in Python language require Python with main version
1096%pyrequires_eq() Requires: %1
1097
1098# Python 3.x
1099# python main version
1100%__python3 /usr/bin/python3
1101%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
1102
1103# directories
1104%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
1105%py3_incdir %{expand:%%global py3_incdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('include'))" 2>/dev/null || echo ERROR)}%py3_incdir
1106%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
1107%py3_sitedir %{py3_libdir}/site-packages
1108%py3_sitescriptdir %{py3_prefix}/share/python%{py3_ver}/site-packages
1109%py3_dyndir %{py3_libdir}/lib-dynload
1110
1111# pure python modules compilation
1112%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1113
1114%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1115
1116%py_build { \
1117 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1118 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1119 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1120 %{?__cc:CC="%{__cc}"; export CC;} \
1121 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1122 %{__python} setup.py \
1123 build --build-base=build-2 \
1124}
1125
1126# "shrink" filter to keep this macro without newlines,
1127# so it could be used as make arguments
1128%py_install_opts() %{shrink: \
1129 --prefix=%{_prefix} \
1130 --install-purelib=%{py_sitescriptdir} \
1131 --install-platlib=%{py_sitedir} \
1132 --optimize=2 \
1133}
1134
1135%py_install { \
1136 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1137 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1138 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1139 %{?__cc:CC="%{__cc}"; export CC;} \
1140 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1141 %{__python} setup.py \
1142 build --build-base=build-2 \
1143 install --skip-build \
1144 %{py_install_opts} \
1145 --root=$RPM_BUILD_ROOT \
1146}
1147
1148%py3_build { \
1149 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1150 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1151 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1152 %{?__cc:CC="%{__cc}"; export CC;} \
1153 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1154 %{__python3} setup.py build --build-base=build-3 \
1155}
1156
1157# "shrink" filter to keep this macro without newlines,
1158# so it could be used as make arguments
1159%py3_install_opts() %{shrink: \
1160 --prefix=%{_prefix} \
1161 --install-purelib=%{py3_sitescriptdir} \
1162 --install-platlib=%{py3_sitedir} \
1163 --optimize=2 \
1164}
1165
1166%py3_install { \
1167 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1168 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1169 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1170 %{?__cc:CC="%{__cc}"; export CC;} \
1171 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1172 %{__python3} setup.py \
1173 build --build-base=build-3 \
1174 install --skip-build \
1175 %{py3_install_opts} \
1176 --root=$RPM_BUILD_ROOT \
1177}
1178
1179# node.js libdir
1180# Requirements:
1181# BuildRequires: rpmbuild(macros) >= 1.634
1182%nodejs_libdir /usr/lib/node_modules
1183
1184# bash-completion 2.0 completions dir
1185# Requirements:
1186# BuildRequires: rpmbuild(macros) >= 1.673
1187# Requires: bash-completion >= 2.0
1188%bash_compdir /usr/share/bash-completion/completions
1189
1190# fish completions dir
1191# Requirements:
1192# BuildRequires: rpmbuild(macros) >= 1.720
1193%fish_compdir /usr/share/fish/vendor_completions.d
1194
1195# zsh completions dir
1196# Requirements:
1197# BuildRequires: rpmbuild(macros) >= 1.719
1198%zsh_compdir /usr/share/zsh/site-functions
1199
1200# Hardlink binary identical .pyc and .pyo files
1201%__spec_install_post_py_hardlink {\
1202%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
1203%{!?debug:set +x;} \
1204local a b c=0 t=0 pyc=%{tmpdir}/%{name}-%{version}-%{release}__rpm_pyc; \
1205if [ -d "$RPM_BUILD_ROOT" ]; then \
1206 find "$RPM_BUILD_ROOT" -name '*.pyc' > $pyc; \
1207 while read a; do \
1208 b="${a%.pyc}.pyo"; \
1209 if cmp -s "$a" "$b"; then \
1210 ln -f "$a" "$b"; \
1211 c=$((c + 1)); \
1212 fi; \
1213 t=$((t + 1)); \
1214 done < $pyc; \
1215 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
1216 rm -f $pyc; \
1217fi; \
1218}; __spec_install_post_py_hardlink } }
1219
1220# Remove Python 2.x sources,
1221# PLD Linux policy is to package only compiled .py[co] for Python 2.x libraries.
1222# Author: Elan Ruusamäe <glen@pld-linux.org>
1223#
1224# Usage:
1225# %py_postclean /usr/share/extra -x keepme.py,keeptoo.py
1226# Options:
1227# -x - comma separated of file basenames to preserve (rpmbuild(macros) >= 1.658)
1228# ARGS - extra directories to clean for .py sources
1229#
1230# BuildRequires: rpmbuild(macros) >= 1.189
1231#
1232%py_postclean(x:) \
1233for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
1234 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 %{-x:| grep -ZzvE '/(%(echo '%{-x*}' | tr ',' '|'))$'} | xargs -0r -l512 rm;\
1235done \
1236%{nil}
1237
1238# depmod macro
1239%depmod() { \
1240umask 022; \
1241if [ -e /boot/System.map-%1 ]; then \
1242 /sbin/depmod -a -F /boot/System.map-%1 %1; \
1243else \
1244 if [ -e /boot/System.map ]; then \
1245 /sbin/depmod -a -F /boot/System.map %1; \
1246 else \
1247 /sbin/depmod -a %1; \
1248 fi \
1249fi; \
1250}
1251
1252# XMMS specific macros
1253%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1254%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1255%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1256%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1257%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1258%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1259%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1260%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1261%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1262%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1263
1264# user/group checking macros
1265#
1266# Usage:
1267# %userremove myuser
1268#
1269%userremove /usr/lib/rpm/user_group.sh user del
1270%groupremove /usr/lib/rpm/user_group.sh group del
1271#
1272# Usage:
1273# if %usertestrm myuser; then
1274# /usr/sbin/userdel -r myuser
1275# Note:
1276# use these macros only if you need to call userdel/groupdel with
1277# a non-standard option or take an extra action; otherwise use the
1278# %userremove/%groupremove macros
1279#
1280%usertestrm /usr/lib/rpm/user_group.sh user testrm
1281%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1282# user group membership management macros
1283#
1284# Usage:
1285# %addusertogroup [-q] myuser agroup
1286#
1287# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1288#
1289# Requirements:
1290# BuildRequires: rpmbuild(macros) >= 1.515
1291%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1292%{nil}
1293
1294# banner support (useful in {pre,post}{,un} and triggers)
1295#
1296# Usage:
1297# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1298# the banner text, the banner text
1299# the banner text, and following line
1300#EOF
1301# You can use any form of here-document, <<'EOF' <<-EOT will do.
1302# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1303#
1304# -a - append to the banner
1305# -e - send to stderr instead of stdout
1306# -n - don't show banner (overrides -t)
1307# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1308# -o - show only once, i.e when package is installed for the first time
1309#
1310# Tests:
1311# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1312# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1313# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1314# rpm -E 'date | %banner -e banner' > m; sh -x m
1315# rpm -E 'date | %banner -o -e banner' > m; sh -x m
1316#
1317%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1318RPM_SCRIPTVERBOSITY=5 \
1319[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1320if [ -x /usr/bin/banner.sh ]; then \
1321 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1322else \
1323 CMD="cat%{-e: >&2}" \
1324fi \
1325eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1326%{nil}
1327
1328# useradd/groupadd macros
1329# Author: Elan Ruusamäe <glen@pld-linux.org>
1330#
1331# Usage:
1332# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1333# [-g initial_group] [-G group[,...]] login
1334#
1335# -u uid. REQUIRED
1336# -g gid/group. REQUIRED
1337# -s defaults to /bin/false
1338# -d defaults to /usr/share/empty
1339# -c No default
1340# -r is accepted but ignored (it's always set)
1341# -k skeleton dir. defaults to /usr/share/empty
1342# rpm specific flags
1343# -P package name. defaults to %{name}
1344#
1345%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1346%{!-u:%{error:useradd: Required argument -u missing}} \
1347%{!-g:%{error:useradd: Required argument -g missing}} \
1348%{!?1:%{error:useradd: Required parameter login missing}} \
1349if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1350 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1351 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1352 exit 1 \
1353 fi \
1354else \
1355 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1356 /usr/sbin/useradd \\\
1357 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1358 -u %{-u*} \\\
1359 -r \\\
1360 -d %{-d*}%{!-d:/usr/share/empty} \\\
1361 -s %{-s*}%{!-s:/bin/false} \\\
1362 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1363 -g %{-g*} \\\
1364 %{-M} \\\
1365 %{-G:-G %{-G*}} \\\
1366 %{expand:%{%{#}}} 1>&2 || exit $? \
1367 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1368fi;
1369# vim: "
1370
1371# Usage:
1372# %groupadd [-P package] [-g gid] group
1373#
1374# -g gid. REQUIRED
1375#
1376# Sample:
1377# %groupadd -P %{name}-base -g %{gid} %{name}
1378
1379%groupadd(g:P:rfo) \
1380%{!-g:%{error:groupadd: Required argument -g missing}} \
1381%{!?1:%{error:groupadd: Required parameter group missing}} \
1382if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1383 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1384 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1385 exit 1 \
1386 fi \
1387else \
1388 echo "Adding group %{1} GID=%{-g*}." \
1389 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1390 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1391fi;
1392
1393# webapp macros
1394# Author: Elan Ruusamäe <glen@pld-linux.org>
1395#
1396# The config is installed/removed inside trigger, this means that you can any
1397# time install apache1/apache/lighttpd package and the configuration file is
1398# updated. if you don't need the config for various reason for specific
1399# webserver, just remove the symlink from config directory using webapp
1400# program. the trigger will not recreate the symlink on upgrades. In other
1401# words the config is linked to webserver config directory on first install of
1402# PACKAGE or WEBSERVER.
1403#
1404# Add package's webserver config to webserver webapps dir.
1405# Usage:
1406# %webapp_register [-f] WEBSERVER WEBAPP
1407#
1408%webapp_register(f) \
1409%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1410if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1411 /usr/sbin/webapp register %1 %2\
1412fi\
1413# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1414if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1415 %{expand:%service -q %%1 reload}\
1416fi\
1417%{nil}
1418
1419# Remove package's config from webserver webapps dir.
1420# Usage:
1421# %webapp_register [-f] WEBSERVER WEBAPP
1422%webapp_unregister(f) \
1423%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1424# remove link if either of the packages are gone \
1425if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1426 /usr/sbin/webapp unregister %1 %2\
1427 %{expand:%service -q %%1 reload}\
1428fi \
1429%{nil}
1430
1431# service macro.
1432# Author: Elan Ruusamäe <glen@pld-linux.org>
1433#
1434# calls usual service restart on package %post, but skips the restart if
1435# administrator has disabled automatic service restarts in either global
1436# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1437# NOTE: systemd_booted machines do not print
1438# Run "{command}" to restart {service}.
1439# message for packages without native systemd unit (not here, no %systemd_post).
1440#
1441# Usage:
1442# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1443#
1444# -q be silent when service isn't started (for scriplets restaring other package's services)
1445# -n NOOP mode, do not actually restart service
1446#
1447# Requirements:
1448# BuildRequires: rpmbuild(macros) >= 1.268
1449# Requires: rc-scripts
1450# -n option:
1451# BuildRequires: rpmbuild(macros) >= 1.450
1452%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1} RPM_BUILD_ROOT=%{buildroot}; /usr/lib/rpm/service_generator.sh %{*}) };}
1453
1454# Java macros. based on jpackage macros.java
1455#
1456# Root directory where all Java VMs/SDK/JREs are installed.
1457%_jvmdir %{_libdir}/jvm
1458
1459# Root directory where all Java VMs/SDK/JREs expose their jars
1460%_jvmjardir %{_libdir}/jvm-exports
1461
1462# Root directory for all Java VM/SDK/JRE's private things.
1463%_jvmprivdir %{_libdir}/jvm-private
1464
1465# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1466%_jvmlibdir %{_libdir}/jvm
1467
1468# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1469%_jvmdatadir %{_datadir}/jvm
1470
1471# Root directory for all configurations parts of Java VM/SDK/JRE's
1472%_jvmsysconfdir %{_sysconfdir}/jvm
1473
1474# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1475%_jvmcommonlibdir %{_libdir}/jvm-common
1476
1477# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1478%_jvmcommondatadir %{_datadir}/jvm-common
1479
1480# Root directory for all common configurations parts of Java VM/SDK/JRE's
1481%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1482
1483# Directory where arch-specific (JNI) version-independent jars are installed.
1484%_jnidir %{_libdir}/java
1485
1486
1487# JDK selection. Set this to name of the JDK implementation to use
1488# insead of the system default
1489#%use_jdk icedtea6
1490
1491# expands to the value with right jdk for BuildRequires header
1492# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1493# The requirement will not replace current 'default' JDK
1494%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1495
1496%buildrequires_jdk BuildRequires: %required_jdk
1497
1498%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1499
1500%_javasrcdir %{_usrsrc}/java
1501
1502%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1503%jar %{java_home}/bin/jar
1504%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1505%javac %{java_home}/bin/javac
1506%javadoc %{java_home}/bin/javadoc
1507
1508%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1509
1510%jpackage_script() \
1511install -d $RPM_BUILD_ROOT%{_bindir}\
1512cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1513#!/bin/sh\
1514#\
1515# %{name} script\
1516# JPackage Project <http://www.jpackage.org/>\
1517\
1518# Source functions library\
1519. %{_javadir}-utils/java-functions\
1520\
1521# Source system prefs\
1522if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1523 . %{_sysconfdir}/java/%{name}.conf\
1524fi\
1525\
1526# Source user prefs\
1527if [ -f $HOME/.%{name}rc ]; then\
1528 . $HOME/.%{name}rc\
1529fi\
1530\
1531# Configuration\
1532MAIN_CLASS=%1\
1533BASE_FLAGS=%2\
1534BASE_OPTIONS=%3\
1535BASE_JARS="%(echo %4 | tr ':' ' ')"\
1536\
1537# Set parameters\
1538set_jvm\
1539set_classpath $BASE_JARS\
1540set_flags $BASE_FLAGS\
1541set_options $BASE_OPTIONS\
1542\
1543# Let's start\
1544run "$@"\
1545EOF
1546
1547# jpackage 1.7
1548# Directory for maven depmaps
1549#
1550%_mavendepmapdir /etc/maven
1551%_mavendepmapfragdir /etc/maven/fragments
1552
1553#
1554# add_to_depmap adds an entry to the depmap. The arguments are:
1555#
1556# %1 the original groupid
1557# %2 the original artifact id
1558# %3 the version
1559# %4 the new groupid
1560# %5 the new artifactid
1561#
1562
1563%add_to_maven_depmap() \
1564install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1565cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1566<dependency>\
1567 <maven>\
1568 <groupId>%1</groupId>\
1569 <artifactId>%2</artifactId>\
1570 <version>%3</version>\
1571 </maven>\
1572 <jpp>\
1573 <groupId>%4</groupId>\
1574 <artifactId>%5</artifactId>\
1575 <version>%3</version>\
1576 </jpp>\
1577</dependency>\
1578\
1579EOF\
1580%{nil}
1581
1582#==============================================================================
1583#
1584# update_maven_depmap updates the main maven depmap
1585#
1586%update_maven_depmap() \
1587echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1588if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1589cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1590fi\
1591echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1592
1593# JAVA macros specific for PLD
1594
1595# Directory for tomcat context configuration files
1596%_tomcatconfdir /etc/tomcat/Catalina/localhost
1597
1598# Tomcat cache path
1599%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1600
1601# Clear tomcat cache
1602# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1603#
1604# Usage:
1605# %%tomcat_clear_cache appname
1606#
1607# Call this script in %postun scriptlet. It will remove compiled jsps related to
1608# given app.
1609#
1610%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1611
1612# PEAR install macros
1613# Author: Elan Ruusamäe <glen@pld-linux.org>
1614#
1615# Usage:
1616# %%pear_package_setup ...
1617#
1618# -a # - also unpack SOURCE#. for PEAR bootstrapping
1619# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
1620# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1621# -D - pass -D to %setup (so the build dir is not removed)
1622# -c - register channel from local channel.xml file
1623# -d - pass -d arg to pearcmd
1624#
1625# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1626# destination hierarchy. you should copy the tree to buildroot after
1627# patching/reorganizing with %%pear_package_install.
1628#
1629# additionally BUILDROOT is stripped from files and files are converted to UNIX
1630# line endings.
1631#
1632# the pear install process output is recorded to install.log, you should put it
1633# to %%doc for later debug or just for information.
1634#
1635# additionally additional-packages.txt is produced if it was detected that the
1636# package has optional dependencies. the file format is suitable of displaying
1637# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1638# automatically added for this file.
1639
1640
1641# records install.log and transforms PEAR names to PLD Linux rpm package names.
1642%__pear_install_log \
1643tee install.log \
1644# make post message of optional packages \
1645grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,' > optional-packages.txt \
1646if [ -s optional-packages.txt ]; then \
1647 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1648else \
1649 rm -f optional-packages.txt \
1650fi \
1651%{nil}
1652
1653# Command invoking PEAR CLI
1654# Same as /usr/bin/pear, except we force GMT timezone
1655%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT /usr/share/pear/pearcmd.php
1656
1657%pear_install(a:d:n:zD) \
1658%__pear \\\
1659 -c %{builddir}/pearrc \\\
1660 -d doc_dir=/docs \\\
1661 -d temp_dir=/tmp \\\
1662 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1663 -d bin_dir=%{_bindir} \\\
1664 -d data_dir=%{php_pear_dir}/data \\\
1665 -d test_dir=%{php_pear_dir}/tests \\\
1666 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1667 install \\\
1668 --packagingroot=%{builddir} \\\
1669 --offline \\\
1670 --nodeps \\\
1671 %{-f:--force} \\\
1672 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1673 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1674%{nil}
1675
1676# The main macro.
1677# using this macro will append optional-packages.txt to the nocompressdoc list
1678# as it's displayed to user after package install. and adding additional gzip
1679# dep is just waste ;)
1680%pear_package_setup(a:d:n:zDc:) \
1681%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
1682%define builddir %{_builddir}/%{srcdir} \
1683%setup -q -c -T %{-D:-D} -n %{srcdir} \
1684%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
1685%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1686%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1687%pear_install \
1688%{-z:cd ..} \
1689%{__tar} --wildcards -zvxf %{S:0} package*.xml \
1690cat %{-z:$_N/}.install.log | %__pear_install_log \
1691%undos -f php,html,js,xml \
1692%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1693%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1694%{nil}
1695
1696# Copies extracted PEAR package structure and PEAR registry to buildroot.
1697# Author: Elan Ruusamäe <glen@pld-linux.org>
1698%pear_package_install() \
1699cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1700# tests should not be packaged \
1701%{__rm} -rf $RPM_BUILD_ROOT%{php_pear_dir}/tests \
1702# cleanup backups \
1703find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1704# help the developer out a little: \
1705if [ -f _noautoreq ]; then \
1706 echo "AutoReqdep detected:" \
1707 echo "_noautoreq $(cat _noautoreq)" \
1708fi \
1709%{nil}
1710
1711# Print optional package info for pear packages
1712# Author: Elan Ruusamäe <glen@pld-linux.org>
1713# Usage:
1714# %post -p <lua>
1715# %%pear_package_print_optionalpackages
1716#
1717# Requirements:
1718# BuildRequires: rpmbuild(macros) >= 1.571
1719%pear_package_print_optionalpackages \
1720f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1721if f then \
1722 for l in f:lines() do print(l); end \
1723 f:close() \
1724end \
1725%{nil}
1726
1727
1728# Register OpenLDAP schema.
1729# Author: Elan Ruusamäe <glen@pld-linux.org>
1730#
1731# Usage:
1732# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1733#
1734# -d specify dependant schemas, separated by comma
1735#
1736%openldap_schema_register(d:) \
1737for schema in %*; do \
1738 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1739 %{__sed} -i -e " \
1740 /^include.*local.schema/{ \
1741 iinclude\\t $schema\
1742 } \
1743 " /etc/openldap/slapd.conf \
1744 fi \
1745done \
1746# enable dependant schemas \
1747if [ "%{-d*}" ]; then \
1748 %{__sed} -i -e ' \
1749 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1750 s/^#// \
1751 }' /etc/openldap/slapd.conf \
1752fi \
1753%{nil}
1754
1755# Unregister OpenLDAP schema.
1756# Author: Elan Ruusamäe <glen@pld-linux.org>
1757#
1758# Usage:
1759# %%openldap_schema_unregister %{schemadir}/horde.schema
1760#
1761%openldap_schema_unregister() \
1762for schema in %*; do \
1763 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1764 %{__sed} -i -e " \
1765 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1766 # for symmetry it would be nice if we disable enabled schemas in post, \
1767 # but we really can not do that, it would break something else. \
1768 " /etc/openldap/slapd.conf \
1769 fi \
1770done \
1771%{nil}
1772
1773%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1774
1775# patchset macros
1776# generate SourceX urls from range START STOP
1777# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1778# The sources start from 10000
1779#
1780# Author: Elan Ruusamäe <glen@pld-linux.org>
1781#
1782# Usage:
1783# %patchset_source -f <seq(1) format> <start> [<end>]
1784# %patchset_patch <start> [<end>]
1785# If <end> is omited, it is assumed to be <start>.
1786#
1787# For example in preamble:
1788# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1789# and in %prep:
1790# %patchset_patch 33 44
1791#
1792# Using sources list:
1793# BuildRequires: rpmbuild(macros) >= 1.426
1794# %patchset_source -f <url> -s <filelist>
1795# %patchset_patch -s <filelist>
1796# For example (ncurses):
1797# BuildRequires: rpmbuild(macros) >= 1.683
1798# %patchset_source -f ftp://dickey.his.com/ncurses/%{basever}/ -s sources
1799# %patchset_patch -s sources -p1
1800#
1801
1802%patchset_source(f:b:s:) %(
1803 base=%{-b*}%{!-b*:10000}
1804%{-s:
1805 baseurl='%{-f*}'
1806 filelist='%{-s*}'
1807 i=$base
1808 while read checksum file; do
1809 printf "Patch%d: %s%s\\n" $i "$baseurl" "$file"
1810 i=$((i+1))
1811 done < $filelist
1812}
1813%{!-s:
1814 start=$(expr $base + %1);
1815 end=$(expr $base + %{?2}%{!?2:%{1}});
1816 # we need to call seq twice as it doesn't allow two formats
1817 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1818 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1819 paste %{tmpdir}/__ps{1,2};
1820 rm -f %{tmpdir}/__ps{1,2};
1821}
1822) \
1823%{nil}
1824
1825# apply sources from %patchset_source
1826# -p specify -pX for %patch line
1827# -b base offset: defaults to 10000
1828# -s filelist to read files from
1829%patchset_patch(f:p:b:s:) %(
1830 base=%{-b*}%{!-b*:10000}
1831 patchlevel=%{-p*:-p%{-p*}}
1832%{-s:
1833 filelist='%{-s*}'
1834 i=$base
1835 while read checksum file; do
1836 printf "patch%d %s\\n" $i "$patchlevel" | sed -e s,^,%%,
1837 i=$((i+1))
1838 done < $filelist
1839}
1840%{!-s:
1841 start=$(expr $base + %1);
1842 end=$(expr $base + %{?2}%{!?2:%{1}});
1843 echo ": patchset_patch %1%{?2: to %2}";
1844 seq -f "patch%g $patchlevel" $start $end | sed -e s,^,%%,;
1845}
1846) \
1847%{nil}
1848
1849# return EXPANDED source url N from current spec
1850%sourceurl(n:) %(test "$IN_RPM" = 1 && exit 1; export IN_RPM=1; rpmbuild --nodigest --nosignature --nobuild -D "prep %%dump" %{_specdir}/%{name}.spec 2>&1 | awk '$2 ~ /^SOURCEURL%{-n*}/ {print $3}')
1851
1852# browser plugins v2
1853# Author: Elan Ruusamäe <glen@pld-linux.org>
1854#
1855# Usage:
1856# %browser_plugins_add_browser <name> -p <plugindir>
1857#
1858# <name> (required) -- name of the browser. usually %{name}.
1859# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1860# -b -- default blacklists
1861# -a <arch> override arch
1862#
1863# Example:
1864# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1865
1866%_browserpluginsconfdir /etc/browser-plugins
1867%_browserpluginsdir %{_libdir}/browser-plugins
1868%update_browser_plugins /usr/sbin/update-browser-plugins || :
1869
1870%browser_plugins_add_browser(p:b:a:) \
1871 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1872 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1873 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1874 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1875 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1876 %{-b:cat >> $blacklist_file %{-b*}} \
1877%{nil}
1878
1879# Helper for LUA.
1880# split string separated by space into quoted list
1881#
1882# Author: Elan Ruusamäe <glen@pld-linux.org>
1883#
1884# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1885%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1886
1887# adjust /etc/shells by adding and removing shells from there
1888# Author: Elan Ruusamäe <glen@pld-linux.org>
1889#
1890# Usage:
1891# %post -p <lua>
1892# %lua_add_etc_shells /bin/sh /bin/pdksh
1893#
1894# %preun -p <lua>
1895# if arg[2] == 0 then
1896# %lua_remove_etc_shells /bin/bash /bin/rbash
1897# end
1898#
1899# Requirements:
1900# BuildRequires: rpmbuild(macros) >= 1.462
1901#
1902
1903%lua_add_etc_shells() \
1904t = {}\
1905f = io.open("/etc/shells", "r")\
1906if f then\
1907 for l in f:lines() do t[l]=l; end\
1908 f:close()\
1909end\
1910for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1911 if not t[s] then\
1912 print("Adding "..s.." to /etc/shells")\
1913 f = io.open("/etc/shells", "a")\
1914 if f then\
1915 f:write(s.."\\n")\
1916 f:close()\
1917 end\
1918 end\
1919end\
1920%{nil}
1921
1922%lua_remove_etc_shells() \
1923t = {}\
1924f = io.open("/etc/shells", "r")\
1925if f then\
1926 for l in f:lines() do t[l]=l; end\
1927 f:close()\
1928end\
1929for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1930 print("Removing "..l.." from /etc/shells")\
1931 t[l] = nil\
1932end\
1933s=""\
1934for _, l in pairs(t) do\
1935 s=s..l.."\\n"\
1936end\
1937f = io.open("/etc/shells", "w")\
1938if f then\
1939 f:write(s)\
1940 f:close()\
1941end\
1942%{nil}
1943
1944# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1945#
1946# Author: Elan Ruusamäe <glen@pld-linux.org>
1947#
1948# Usage:
1949# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1950# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1951#
1952# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1953#
1954# Requirements:
1955# BuildRequires: rpmbuild(macros) >= 1.429
1956#
1957%add_etc_shells(p) %{-p:<lua>}\
1958%{expand:%%lua_add_etc_shells %*}\
1959%{nil}
1960
1961%remove_etc_shells(p) %{-p:<lua>}\
1962%{-p:if arg[2] == 0 then}\
1963%{expand:%%lua_remove_etc_shells %*}\
1964%{-p:end} \
1965%{nil}
1966
1967# Check syntax for Python files
1968#
1969# Author: Elan Ruusamäe <glen@pld-linux.org>
1970# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1971#
1972# Usage:
1973# %py_lint src
1974#
1975# Requirements:
1976# BuildRequires: python
1977# BuildRequires: rpmbuild(macros) >= 1.602
1978
1979%py_lint() \
1980__py_lint() { \
1981%{!?debug:set +x;} \
1982find "$@" -type f -name '*.py' | python -c ' \
1983import sys \
1984import compiler \
1985\
1986found = err = 0\
1987for f in sys.stdin: \
1988 fd = open(f.rstrip()) \
1989 c = fd.read() \
1990 fd.close() \
1991 found = found + 1 \
1992 try: \
1993 compiler.parse(c) \
1994 except SyntaxError, e: \
1995 print "py_lint: %s: %s" % (f.rstrip(), e) \
1996 err = err + 1\
1997\
1998if not found:\
1999 print >> sys.stderr, "\\npy_lint: ERROR: No files processed.\\n" \
2000 sys.exit(1) \
2001elif err: \
2002 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
2003 sys.exit(1) \
2004else: \
2005 print >> sys.stderr, "py_lint: %d files scanned, found no syntax errors." % found \
2006' \
2007}; __py_lint %* \
2008%{nil}
2009
2010# Undos files
2011#
2012# Author: Paweł Zuzelski <pawelz@pld-linux.org>
2013# Author: Elan Ruusamäe <glen@pld-linux.org>
2014#
2015# Usage:
2016# %undos list_of_files
2017# %undos -f EXT[,EXT]
2018# %undos -i -f EXT[,EXT]
2019#
2020# -f EXT[,EXT] - find(1) files by extensions
2021# -i - case insensitive file search
2022#
2023# Example:
2024# Un-DOS all *.js, *.css files
2025# %undos -f js,css
2026# Un-DOS all *.js, *.JS files
2027# %undos -f js -i
2028# undos all Makefiles
2029# %{__find} -name Makefile | xargs %undos
2030#
2031# Requirements:
2032# BuildRequires: sed >= 4.0
2033# BuildRequires: rpmbuild(macros) >= 1.674
2034
2035# NB: make sure this macro stays on one line
2036# NB: make sure it includes newline escape
2037%undos(f:i) %{-f:%{__find} -type f -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
2038%{nil}
2039
2040# Hook to register nagios object based plugins in Nagios NRPE daemon config.
2041#
2042# Author: Elan Ruusamäe <glen@pld-linux.org>
2043#
2044# Usage:
2045# -a NAME -- add command named NAME
2046# -d NAME -- remove command named NAME
2047# -f FILE -- specify plugin configuration FILE to extract command definition from
2048#
2049# Sample:
2050# %triggerin -- nagios-nrpe
2051# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2052#
2053# %triggerun -- nagios-nrpe
2054# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2055#
2056# Requirements:
2057# Requires: grep
2058# Requires: sed >= 4.0
2059# BuildRequires: rpmbuild(macros) >= 1.685
2060%nagios_nrpe(a:d:c:f:) {\
2061 if %{__grep} -q '^include_dir=/etc/nagios/nrpe.d' /etc/nagios/nrpe.cfg && [ -d /etc/nagios/nrpe.d ]; then \
2062 file=/etc/nagios/nrpe.d/%{-a*}%{-d*}.cfg; \
2063 else \
2064 file=/etc/nagios/nrpe.cfg; \
2065 fi; \
2066 m=$(test -f $file && md5sum < $file); \
2067 %{-a:# on -a and config exists \
2068 if [ -f /etc/nagios/nrpe.cfg ]; then \
2069 if [ ! -f $file ] || ! %{__grep} -q '^command\[%{-a*}\]' $file; then \
2070 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> $file; \
2071 fi; \
2072 fi;} \
2073 %{-d:# on package remove, -d and config exists \
2074 if [ "$1" = "0" -a -f $file ]; then \
2075 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' $file; \
2076 fi;} \
2077 if [ "$m" != "$(md5sum < $file)" ]; then \
2078 %service -q nrpe restart; \
2079 fi; \
2080}%{nil}
2081
2082# Import or update Cacti template.
2083#
2084# Author: Elan Ruusamäe <glen@pld-linux.org>
2085#
2086# Usage:
2087# %cacti_import_template XMLFILE
2088# XMLFILE -- XML template to import
2089#
2090# Sample:
2091# %post
2092# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
2093#
2094# Requires: cacti >= 0.8.7e-8
2095# BuildRequires: rpmbuild(macros) >= 1.630
2096# Note: 1.1 (cacti-0.8.7h) adds requirement for --with-template-rras or --with-user-rras option
2097
2098%cacti_import_template() {\
2099v=$(%{__sed} -rne 's/.+Add Graphs Script ([0-9\.]+).+/\1/p' /usr/share/cacti/cli/import_template.php); \
2100if [ "$v" != "1.0" ]; then \
2101 rra="--with-template-rras"; \
2102fi; \
2103/usr/share/cacti/cli/import_template.php --filename=%1 $rra || :; \
2104}%{nil}
2105
2106# pre/post script for -upstart subpackages
2107#
2108# Author: Jacek Konieczny <jajcus@jajcus.net>
2109# Author: Elan Ruusamäe <glen@pld-linux.org>
2110#
2111# Usage:
2112# %upstart_post service_name
2113# %upstart_postun service_name
2114#
2115# Sample:
2116# %post upstart
2117# %upstart_post %{name}
2118#
2119# %postun upstart
2120# %upstart_postun %{name}
2121#
2122# Requirements:
2123# BuildRequires: rpmbuild(macros) >= 1.690
2124# Requires: rc-scripts >= 0.4.3
2125
2126# migrate from init script to upstart job
2127%upstart_post() \
2128 if [ -x /sbin/initctl ] && [ -f /var/lock/subsys/%1 ]; then \
2129 /sbin/service --no-upstart %1 stop \
2130 /sbin/service %1 start \
2131 fi \
2132%{nil}
2133
2134# restart the job after upgrade or migrate to init script on removal
2135# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
2136# at this point
2137%upstart_postun() \
2138 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
2139 /sbin/initctl stop %1 >/dev/null 2>&1 \
2140 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
2141 fi \
2142%{nil}
2143
2144# Haskell Macros
2145# BuildRequires: rpmbuild(macros) >= 1.608
2146%ghcdir ghc-%(/usr/bin/ghc --numeric-version 2>/dev/null || echo ERROR)
2147
2148# update /usr/lib*/ghc-*/package.conf.d/package.cache
2149# Requires: ghc
2150# BuildRequires: rpmbuild(macros) >= 1.607
2151#
2152%ghc_pkg_recache() {{ \
2153 umask 022; \
2154 [ ! -x /usr/bin/ghc-pkg ] || /usr/bin/ghc-pkg recache; \
2155};} \
2156%{nil}
2157
2158
2159# pre/post script for packages supporting systemd units
2160#
2161# Authors: Bartlomiej Zimon <uzi18@o2.pl>
2162# Jan Rękorajski <baggins@mimuw.edu.pl>
2163#
2164# Usage:
2165# %systemd_reload
2166# %systemd_service <unit command> service_name1.service service_name2.service
2167# %systemd_service_enable service_name1.service service_name2.service
2168# %systemd_service_disable service_name1.service service_name2.service
2169# %systemd_service_start service_name1.service service_name2.service
2170# %systemd_service_stop service_name1.service service_name2.service
2171# %systemd_service_restart service_name1.service service_name2.service
2172# %systemd_service_reload service_name1.service service_name2.service
2173#
2174# %systemd_post service_name1.service service_name2.service
2175# %systemd_preun service_name1.service service_name2.service
2176# %systemd_trigger service_name1.service service_name2.service
2177#
2178# Sample:
2179# %post
2180# %systemd_post %{name}.service
2181#
2182# %preun
2183# %systemd_preun %{name}.service
2184#
2185# %postun
2186# %systemd_reload
2187#
2188# %triggerpostun -- %{name} < first-version-with-systemd-units
2189# %systemd_trigger %{name}.service
2190#
2191# Requirements:
2192# BuildRequires: rpmbuild(macros) >= 1.671
2193# Requires: systemd-units >= 38
2194
2195%systemd_reload /bin/systemd_booted && SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog /bin/systemctl daemon-reload || :
2196
2197%systemd_service_enable() \
2198 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2199 /bin/systemctl preset --preset-mode=enable-only %{*} || : \
2200 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2201%{nil}
2202
2203%systemd_service_disable() \
2204 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2205 /bin/systemctl --quiet disable %{*} || : \
2206%{nil}
2207
2208%systemd_service() \
2209 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2210 /bin/systemd_booted && /bin/systemctl %{*} || : \
2211%{nil}
2212
2213%systemd_service_start() \
2214 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2215 /bin/systemd_booted && /bin/systemctl start %{*} || : \
2216%{nil}
2217
2218%systemd_service_stop() \
2219 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2220 /bin/systemd_booted && /bin/systemctl stop %{*} || : \
2221%{nil}
2222
2223# NOTE: doesn't honour RPM_SKIP_AUTO_RESTART, avoid using
2224%systemd_service_restart() \
2225 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2226 /bin/systemd_booted && /bin/systemctl try-restart %{*} || : \
2227%{nil}
2228
2229# NOTE: doesn't honour RPM_SKIP_AUTO_RESTART, avoid using
2230%systemd_service_reload() \
2231 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2232 /bin/systemd_booted && /bin/systemctl reload %{*} || : \
2233%{nil}
2234
2235# NOTE: this trigger disobeys systemd.preset in favour of RPM_ENABLE_SYSTEMD_SERVICE
2236%systemd_trigger() \
2237want_enable_service() { \
2238 [ -f /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
2239 [ ${RPM_ENABLE_SYSTEMD_SERVICE:-yes} = no ] && return 1 \
2240 [ "$(echo /etc/rc.d/rc[0-6].d/S[0-9][0-9]${1%.service})" = "/etc/rc.d/rc[0-6].d/S[0-9][0-9]${1%.service}" ] && return 1 \
2241 return 0 \
2242}\
2243 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2244 for s in %{*}; do \
2245 if want_enable_service $s; then \
2246 /bin/systemctl --quiet enable $s || : \
2247 fi \
2248 done \
2249%{nil}
2250
2251%systemd_post() \
2252 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2253 /bin/systemd_booted && /bin/systemctl daemon-reload || : \
2254 if [ $1 -eq 1 ]; then \
2255 /bin/systemctl preset --preset-mode=enable-only %{*} || >/dev/null : \
2256 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2257 elif [ -z "$NORESTART" ]; then \
2258 /bin/systemd_booted && /bin/systemctl try-restart %{*} || : \
2259 else \
2260 /bin/systemd_booted && echo 'Run "/bin/systemctl restart %{*}" to restart %{*}.' || : \
2261 fi \
2262%{nil}
2263
2264%systemd_preun() \
2265 if [ $1 -eq 0 ]; then \
2266 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2267 /bin/systemd_booted && /bin/systemctl stop %{*} || : \
2268 /bin/systemctl --quiet disable %{*} || : \
2269 fi \
2270%{nil}
2271
2272%systemdunitdir /lib/systemd/system
2273%systemduserunitdir /usr/lib/systemd/user
2274%systemdtmpfilesdir /usr/lib/tmpfiles.d
2275
2276#-----------------------------------------------------------------
2277# Update hardware database index
2278#
2279# Requirements:
2280# BuildRequires: rpmbuild(macros) >= 1.691
2281# Requires: udev-core >= 1:196
2282
2283%udev_hwdb_update() \
2284/sbin/udevadm hwdb --update >/dev/null 2>&1 || : \
2285%{nil}
2286
2287# Generate vim help tags file
2288#
2289# Requirements:
2290# BuildRequires: rpmbuild(macros) >= 1.718
2291# Requires(post,postun): /usr/bin/vim
2292# Requires(post,postun): vim-rt >= 4:7.4.2054-2
2293%vim_doc_helptags() \
2294umask 022; \
2295/usr/bin/vim -c ':helptags /usr/share/vim/doc' -c ':q' 2>/dev/null \
2296%{nil}
2297
2298# EOF
This page took 0.053671 seconds and 4 git commands to generate.